.na
.TH SL4UTIL 1 bogslab
.SH NAME
sl4util -- search and alter SuperLab 4 scenarios
.SH SYNOPSIS
sl4util [-x|-d|-p] [{-l|-L}nnn[:fff][+sss][@ccc[-[ddd]]]] file.sl4
.SH DESCRIPTION
This file is a kludge that can be used to dump, to extract stimulus
lists, and to replace stimulus lists in existing SuperLab 4 sl4 scenario
files.  This is useful primarily to do complicated randomizations and
counterbalancing that is difficult to do within SuperLab.
.PP
The -x, -d, and -p command flags are mutually exclusive.
If the -d flag is given, a dump of file.sl4 is given, a blend of hex
bytes and strings. This could be useful to help figure out the format
of the files. If the -x flag is given, the contents of a stimulus list
is written to standard output. In this mode, there must be exactly one
-l flag used, and it must specify the name nnn of an existing stimulus
list. If the -p flag is given, then one or more stimulus lists are
replaced with the contents of files specified using the -l flag. Unless
a skip is given, the
files must contain the same number of lines as the number of stimuli
in the existing list. The -l or -L flag must have the name nnn of a stimulus
list, optionally followed by a path to a new stimulus list file fff,
separated from the name with a colon. Also, there can be an optional
number of lines to skip preceded by a '+', and a range of columns to
use preceded by an '@'. A range can be either a plain number, indicating
a single column, two numbers separated by '-' indicating a set of
adjacent columns, or a plain number followed by '-', indicating all
columns starting at a certain column. Use of -L causes alphabetic
characters in the range to be converted to uppercase. Note that when
-x is used, only -l with an unadorned name is allowed; neither -L or
-l are allowed with -d.
.SH DIAGNOSTICS
Various error messages are written out. It tries to detect errors before
any data is emitted.
.SH BUGS
The sl4util is inherently fragile and vulnerable to changes in the
sl4 format.  It uses dead reckoning and magic numbers to navigate
the sl4 file. In some cases, bugs will cause SuperLab to crash, but
it is possible for there to be more subtle errors that simply cause
experiments to behave incorrectly.  Also, sl4util is currently very
limited, but the intention is that it can be expanded, for example, to
handle stimulus lists with other than textual stimuli, to allow
event parameters such as timing to be altered, to allow stimulus
codes to be specified, or even to allow the construction of an entire
scenario from scratch.
